const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Patient_profilesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const patient_profiles = await db.patient_profiles.create(
      {
        id: data.id || undefined,

        health_metrics: data.health_metrics || null,
        prescriptions: data.prescriptions || null,
        appointments: data.appointments || null,
        billing: data.billing || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await patient_profiles.setSubscriber(data.subscriber || null, {
      transaction,
    });

    await patient_profiles.setOrganizations(data.organizations || null, {
      transaction,
    });

    return patient_profiles;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const patient_profilesData = data.map((item, index) => ({
      id: item.id || undefined,

      health_metrics: item.health_metrics || null,
      prescriptions: item.prescriptions || null,
      appointments: item.appointments || null,
      billing: item.billing || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const patient_profiles = await db.patient_profiles.bulkCreate(
      patient_profilesData,
      { transaction },
    );

    // For each item created, replace relation files

    return patient_profiles;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const patient_profiles = await db.patient_profiles.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.health_metrics !== undefined)
      updatePayload.health_metrics = data.health_metrics;

    if (data.prescriptions !== undefined)
      updatePayload.prescriptions = data.prescriptions;

    if (data.appointments !== undefined)
      updatePayload.appointments = data.appointments;

    if (data.billing !== undefined) updatePayload.billing = data.billing;

    updatePayload.updatedById = currentUser.id;

    await patient_profiles.update(updatePayload, { transaction });

    if (data.subscriber !== undefined) {
      await patient_profiles.setSubscriber(
        data.subscriber,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await patient_profiles.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return patient_profiles;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const patient_profiles = await db.patient_profiles.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of patient_profiles) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of patient_profiles) {
        await record.destroy({ transaction });
      }
    });

    return patient_profiles;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const patient_profiles = await db.patient_profiles.findByPk(id, options);

    await patient_profiles.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await patient_profiles.destroy({
      transaction,
    });

    return patient_profiles;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const patient_profiles = await db.patient_profiles.findOne(
      { where },
      { transaction },
    );

    if (!patient_profiles) {
      return patient_profiles;
    }

    const output = patient_profiles.get({ plain: true });

    output.subscriber = await patient_profiles.getSubscriber({
      transaction,
    });

    output.organizations = await patient_profiles.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.subscribers,
        as: 'subscriber',

        where: filter.subscriber
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.subscriber
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.subscriber
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.health_metrics) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'patient_profiles',
            'health_metrics',
            filter.health_metrics,
          ),
        };
      }

      if (filter.prescriptions) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'patient_profiles',
            'prescriptions',
            filter.prescriptions,
          ),
        };
      }

      if (filter.appointments) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'patient_profiles',
            'appointments',
            filter.appointments,
          ),
        };
      }

      if (filter.billing) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('patient_profiles', 'billing', filter.billing),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.patient_profiles.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('patient_profiles', 'id', query),
        ],
      };
    }

    const records = await db.patient_profiles.findAll({
      attributes: ['id', 'id'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['id', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.id,
    }));
  }
};
